/** @file sdl_screenmode.h

	Skelton for retropc emulator

	@author Sasaji
	@date   2019.10.01

	@brief [ screen mode ]
*/

#ifndef SDL_SCREEN_MODE_H
#define SDL_SCREEN_MODE_H

#include "../../common.h"


class ScreenMode
{
private:
	int monitor_count;

	int disp_device_count;
	disp_device_t disp_device[DISP_DEVICE_MAX];

	int screen_mode_count;
	screen_mode_t screen_mode[SCREEN_MODE_MAX];

	static int qsort_by_n_w_h(const void *a, const void *b);

public:
	ScreenMode();
	~ScreenMode();

	void Enum(int desktop_width, int desktop_height, uint32_t flags);

	int CountMode() const { return screen_mode_count; }
	const screen_mode_t *GetMode(int num) const;
	int FindMode(int disp_no, int width, int height) const;

	int CountDisp() const { return disp_device_count; }
	const disp_device_t *GetDisp(int num) const;
};

#endif /* SDL_SCREEN_MODE_H */
