/** @file screenmode.h

	Skelton for retropc emulator

	@author Sasaji
	@date   2019.10.01

	@brief [ screen mode ]
*/

#ifndef SCREEN_MODE_H
#define SCREEN_MODE_H

#include "../common.h"
#include "../cchar.h"
#include "../res/resource.h"


#define DISP_DEVICE_MAX 3
typedef struct disp_device_st {
	CTchar   name;
	VmRectWH re;
} disp_device_t;

#define SCREEN_MODE_MAX (ID_SCREEN_FULLSCREEN24 - ID_SCREEN_FULLSCREEN1 + 1)
typedef struct screen_mode_st {
	int disp_no;
	int width;
	int height;
} screen_mode_t;


#if defined(USE_WIN)
#include "windows/win_screenmode.h"
#elif defined(USE_SDL) || defined(USE_SDL2)
#include "SDL/sdl_screenmode.h"
#elif defined(USE_WX) || defined(USE_WX2)
#include "wxwidgets/wxw_screenmode.h"
#elif defined(USE_QT)
#include "qt/qt_screenmode.h"
#endif

#endif /* SCREEN_MODE_H */
