/** @file windowmode.h

	Skelton for retropc emulator

	@author Sasaji
	@date   2019.10.01

	@brief [ window mode ]
*/

#ifndef WINDOW_MODE_H
#define WINDOW_MODE_H

#include "../res/resource.h"

#define WINDOW_MODE_MAX (ID_SCREEN_WINDOW8 - ID_SCREEN_WINDOW1 + 1)
typedef struct window_mode_st {
	int power;
	int width;
	int height;
} window_mode_t;

class EMU;

extern EMU *emu;

class WindowMode
{
private:
	int window_mode_count;
	window_mode_t window_mode[WINDOW_MODE_MAX];

	static int qsort_by_w_h_n(const void *a, const void *b);

public:
	WindowMode();
	~WindowMode();

	void Enum(int max_width, int max_height);

	int Count() const { return window_mode_count; }
	const window_mode_t *Get(int num) const;
	int Find(int width, int height) const;
};

#endif /* WINDOW_MODE_H */
